/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 19 "../src/vlog/vlog-parse.y"

#include "util.h"
#include "diag.h"
#include "ident.h"
#include "lib.h"
#include "object.h"
#include "scan.h"
#include "vlog/vlog-node.h"
#include "vlog/vlog-phase.h"

#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define YYLTYPE loc_t
#define YYSTYPE yylval_t
#define YYTOKENTYPE token_t

#define YYEMPTY -2
#define YYEOF tEOF
#define YYerror -3
#define YYUNDEF tERROR

#define yylex processed_yylex

typedef struct _node_list node_list_t;

struct _node_list {
   node_list_t *next;
   node_list_t *tail;
   vlog_node_t  value;
};

static void yyerror(const char *s);

static void node_list_append(node_list_t **l, vlog_node_t v);
static void node_list_concat(node_list_t **a, node_list_t *b);
static node_list_t *node_list_single(vlog_node_t v);
static void node_list_free(node_list_t *l);

static void set_timescale(const char *unit_value, const char *unit_name,
                          const char *prec_value, const char *prec_name,
                          const loc_t *loc);
static void clone_port(node_list_t **list, vlog_node_t p);

#define YYLLOC_DEFAULT(Current, Rhs, N) {                            \
   if (N) {                                                          \
      (Current) = get_loc(YYRHSLOC(Rhs, 1).first_line,               \
                          YYRHSLOC(Rhs, 1).first_column,             \
                          YYRHSLOC(Rhs, N).first_line +              \
                          YYRHSLOC(Rhs, N).line_delta,               \
                          YYRHSLOC(Rhs, N).first_column +            \
                          YYRHSLOC(Rhs, N).column_delta,             \
                          YYRHSLOC(Rhs, N).file_ref);                \
   }                                                                 \
   else {                                                            \
      (Current) = YYRHSLOC(Rhs, 0);                                  \
   }                                                                 \
 }

static vlog_node_t root;

static void add_port(vlog_node_t module, vlog_node_t port)
{
   switch (vlog_kind(port)) {
   case V_PORT_DECL:
      {
         // Verilog-2001 style port declaration
         vlog_node_t ref = vlog_new(V_REF);
         vlog_set_loc(ref, vlog_loc(port));
         vlog_set_ident(ref, vlog_ident(port));
         vlog_set_ref(ref, port);

         vlog_add_port(module, ref);
         vlog_add_decl(module, port);
      }
      break;
   case V_REF:
      vlog_add_port(module, port);
      break;
   case V_NET_DECL:
   case V_VAR_DECL:
      vlog_add_decl(module, port);
      break;
   default:
      fatal_trace("unexpected %s in port list", vlog_kind_str(vlog_kind(port)));
   }
}

static bool is_decl(vlog_node_t v)
{
   switch (vlog_kind(v)) {
   case V_PORT_DECL:
   case V_NET_DECL:
   case V_VAR_DECL:
      return true;
   default:
      return false;
   }
}

static vlog_node_t make_strength(vlog_strength_t value, const loc_t *loc)
{
   vlog_node_t s = vlog_new(V_STRENGTH);
   vlog_set_loc(s, loc);
   vlog_set_subkind(s, value);
   return s;
}


#line 183 "../src/vlog/vlog-parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    tEOF = 0,                      /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 416,                 /* "invalid token"  */
    tID = 200,                     /* "identifier"  */
    tSYSTASK = 383,                /* "system task identifier"  */
    tSTRING = 229,                 /* "string"  */
    tUNSIGNED = 359,               /* "unsigned number"  */
    tMODULE = 350,                 /* "module"  */
    tENDMODULE = 351,              /* "endmodule"  */
    tINPUT = 352,                  /* "input"  */
    tOUTPUT = 353,                 /* "output"  */
    tINOUT = 231,                  /* "inout"  */
    tREG = 354,                    /* "reg"  */
    tALWAYS = 336,                 /* "always"  */
    tINITIAL = 357,                /* "initial"  */
    tPOSEDGE = 355,                /* "posedge"  */
    tNEGEDGE = 356,                /* "negedge"  */
    tBEGIN = 211,                  /* "begin"  */
    tEND = 203,                    /* "end"  */
    tLE = 294,                     /* "<="  */
    tWIRE = 358,                   /* "wire"  */
    tASSIGN = 227,                 /* "assign"  */
    tIF = 234,                     /* "if"  */
    tASSOC = 248,                  /* "=>"  */
    tELSE = 255,                   /* "else"  */
    tTIMESCALE = 399,              /* "`timescale"  */
    tSUPPLY0 = 400,                /* "supply0"  */
    tSUPPLY1 = 401,                /* "supply1"  */
    tPULLDOWN = 402,               /* "pulldown"  */
    tPULLUP = 403,                 /* "pullup"  */
    tCASEEQ = 404,                 /* "==="  */
    tCASENEQ = 405,                /* "!=="  */
    tLOGEQ = 406,                  /* "=="  */
    tLOGNEQ = 407,                 /* "!="  */
    tATTRBEGIN = 408,              /* "(*"  */
    tATTREND = 409,                /* "*)"  */
    tNUMBER = 410,                 /* "number"  */
    tFOREVER = 411,                /* "forever"  */
    tSPECIFY = 414,                /* "specify"  */
    tENDSPECIFY = 415              /* "endspecify"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;

int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tID = 3,                        /* "identifier"  */
  YYSYMBOL_tSYSTASK = 4,                   /* "system task identifier"  */
  YYSYMBOL_tSTRING = 5,                    /* "string"  */
  YYSYMBOL_tUNSIGNED = 6,                  /* "unsigned number"  */
  YYSYMBOL_tMODULE = 7,                    /* "module"  */
  YYSYMBOL_tENDMODULE = 8,                 /* "endmodule"  */
  YYSYMBOL_tINPUT = 9,                     /* "input"  */
  YYSYMBOL_tOUTPUT = 10,                   /* "output"  */
  YYSYMBOL_tINOUT = 11,                    /* "inout"  */
  YYSYMBOL_tREG = 12,                      /* "reg"  */
  YYSYMBOL_tALWAYS = 13,                   /* "always"  */
  YYSYMBOL_tINITIAL = 14,                  /* "initial"  */
  YYSYMBOL_tPOSEDGE = 15,                  /* "posedge"  */
  YYSYMBOL_tNEGEDGE = 16,                  /* "negedge"  */
  YYSYMBOL_tBEGIN = 17,                    /* "begin"  */
  YYSYMBOL_tEND = 18,                      /* "end"  */
  YYSYMBOL_tLE = 19,                       /* "<="  */
  YYSYMBOL_tWIRE = 20,                     /* "wire"  */
  YYSYMBOL_tASSIGN = 21,                   /* "assign"  */
  YYSYMBOL_tIF = 22,                       /* "if"  */
  YYSYMBOL_tASSOC = 23,                    /* "=>"  */
  YYSYMBOL_tELSE = 24,                     /* "else"  */
  YYSYMBOL_tTIMESCALE = 25,                /* "`timescale"  */
  YYSYMBOL_tSUPPLY0 = 26,                  /* "supply0"  */
  YYSYMBOL_tSUPPLY1 = 27,                  /* "supply1"  */
  YYSYMBOL_tPULLDOWN = 28,                 /* "pulldown"  */
  YYSYMBOL_tPULLUP = 29,                   /* "pullup"  */
  YYSYMBOL_tCASEEQ = 30,                   /* "==="  */
  YYSYMBOL_tCASENEQ = 31,                  /* "!=="  */
  YYSYMBOL_tLOGEQ = 32,                    /* "=="  */
  YYSYMBOL_tLOGNEQ = 33,                   /* "!="  */
  YYSYMBOL_tATTRBEGIN = 34,                /* "(*"  */
  YYSYMBOL_tATTREND = 35,                  /* "*)"  */
  YYSYMBOL_tNUMBER = 36,                   /* "number"  */
  YYSYMBOL_tFOREVER = 37,                  /* "forever"  */
  YYSYMBOL_tSPECIFY = 38,                  /* "specify"  */
  YYSYMBOL_tENDSPECIFY = 39,               /* "endspecify"  */
  YYSYMBOL_40_ = 40,                       /* '|'  */
  YYSYMBOL_41_ = 41,                       /* '&'  */
  YYSYMBOL_42_ = 42,                       /* '+'  */
  YYSYMBOL_43_ = 43,                       /* '-'  */
  YYSYMBOL_44_ = 44,                       /* '*'  */
  YYSYMBOL_45_ = 45,                       /* '/'  */
  YYSYMBOL_46_ = 46,                       /* '%'  */
  YYSYMBOL_47_ = 47,                       /* '~'  */
  YYSYMBOL_48_ = 48,                       /* '!'  */
  YYSYMBOL_49_then_ = 49,                  /* "then"  */
  YYSYMBOL_50_ = 50,                       /* ';'  */
  YYSYMBOL_51_ = 51,                       /* '('  */
  YYSYMBOL_52_ = 52,                       /* ')'  */
  YYSYMBOL_53_ = 53,                       /* ','  */
  YYSYMBOL_54_ = 54,                       /* '['  */
  YYSYMBOL_55_ = 55,                       /* ':'  */
  YYSYMBOL_56_ = 56,                       /* ']'  */
  YYSYMBOL_57_ = 57,                       /* '='  */
  YYSYMBOL_58_ = 58,                       /* '#'  */
  YYSYMBOL_59_ = 59,                       /* '@'  */
  YYSYMBOL_60_ = 60,                       /* '.'  */
  YYSYMBOL_YYACCEPT = 61,                  /* $accept  */
  YYSYMBOL_source_text = 62,               /* source_text  */
  YYSYMBOL_directive_list = 63,            /* directive_list  */
  YYSYMBOL_timescale_compiler_directive = 64, /* timescale_compiler_directive  */
  YYSYMBOL_description = 65,               /* description  */
  YYSYMBOL_66_1 = 66,                      /* $@1  */
  YYSYMBOL_attr_spec = 67,                 /* attr_spec  */
  YYSYMBOL_attr_list_opt = 68,             /* attr_list_opt  */
  YYSYMBOL_module_declaration = 69,        /* module_declaration  */
  YYSYMBOL_module_port_list_opt = 70,      /* module_port_list_opt  */
  YYSYMBOL_list_of_ports = 71,             /* list_of_ports  */
  YYSYMBOL_port = 72,                      /* port  */
  YYSYMBOL_port_reference = 73,            /* port_reference  */
  YYSYMBOL_port_identifier = 74,           /* port_identifier  */
  YYSYMBOL_list_of_port_declarations = 75, /* list_of_port_declarations  */
  YYSYMBOL_range_opt = 76,                 /* range_opt  */
  YYSYMBOL_port_declaration_head = 77,     /* port_declaration_head  */
  YYSYMBOL_port_declaration = 78,          /* port_declaration  */
  YYSYMBOL_module_item_list_opt = 79,      /* module_item_list_opt  */
  YYSYMBOL_module_item_list = 80,          /* module_item_list  */
  YYSYMBOL_module_item = 81,               /* module_item  */
  YYSYMBOL_module_or_generate_item = 82,   /* module_or_generate_item  */
  YYSYMBOL_module_instantiation = 83,      /* module_instantiation  */
  YYSYMBOL_module_instance = 84,           /* module_instance  */
  YYSYMBOL_list_of_port_connections_opt = 85, /* list_of_port_connections_opt  */
  YYSYMBOL_list_of_port_connections = 86,  /* list_of_port_connections  */
  YYSYMBOL_module_or_generate_item_declaration = 87, /* module_or_generate_item_declaration  */
  YYSYMBOL_specify_block = 88,             /* specify_block  */
  YYSYMBOL_specify_item_list_opt = 89,     /* specify_item_list_opt  */
  YYSYMBOL_specify_item_list = 90,         /* specify_item_list  */
  YYSYMBOL_specify_item = 91,              /* specify_item  */
  YYSYMBOL_path_declaration = 92,          /* path_declaration  */
  YYSYMBOL_simple_path_declaration = 93,   /* simple_path_declaration  */
  YYSYMBOL_parallel_path_description = 94, /* parallel_path_description  */
  YYSYMBOL_path_delay_value = 95,          /* path_delay_value  */
  YYSYMBOL_list_of_path_delay_expressions = 96, /* list_of_path_delay_expressions  */
  YYSYMBOL_path_delay_expression = 97,     /* path_delay_expression  */
  YYSYMBOL_constant_expression = 98,       /* constant_expression  */
  YYSYMBOL_constant_primary = 99,          /* constant_primary  */
  YYSYMBOL_net_declaration = 100,          /* net_declaration  */
  YYSYMBOL_net_type = 101,                 /* net_type  */
  YYSYMBOL_list_of_net_identifiers = 102,  /* list_of_net_identifiers  */
  YYSYMBOL_reg_declaration = 103,          /* reg_declaration  */
  YYSYMBOL_list_of_variable_identifiers = 104, /* list_of_variable_identifiers  */
  YYSYMBOL_variable_type = 105,            /* variable_type  */
  YYSYMBOL_continuous_assign = 106,        /* continuous_assign  */
  YYSYMBOL_list_of_net_assignments = 107,  /* list_of_net_assignments  */
  YYSYMBOL_net_assignment = 108,           /* net_assignment  */
  YYSYMBOL_always_construct = 109,         /* always_construct  */
  YYSYMBOL_initial_construct = 110,        /* initial_construct  */
  YYSYMBOL_statement = 111,                /* statement  */
  YYSYMBOL_statement_or_null = 112,        /* statement_or_null  */
  YYSYMBOL_list_of_statements_opt = 113,   /* list_of_statements_opt  */
  YYSYMBOL_list_of_statements = 114,       /* list_of_statements  */
  YYSYMBOL_conditional_statement = 115,    /* conditional_statement  */
  YYSYMBOL_system_task_enable = 116,       /* system_task_enable  */
  YYSYMBOL_system_function_call = 117,     /* system_function_call  */
  YYSYMBOL_seq_block = 118,                /* seq_block  */
  YYSYMBOL_nonblocking_assignment = 119,   /* nonblocking_assignment  */
  YYSYMBOL_blocking_assignment = 120,      /* blocking_assignment  */
  YYSYMBOL_procedural_timing_control_statement = 121, /* procedural_timing_control_statement  */
  YYSYMBOL_delay_or_event_control = 122,   /* delay_or_event_control  */
  YYSYMBOL_delay_control = 123,            /* delay_control  */
  YYSYMBOL_delay_value = 124,              /* delay_value  */
  YYSYMBOL_event_control = 125,            /* event_control  */
  YYSYMBOL_event_expression = 126,         /* event_expression  */
  YYSYMBOL_loop_statement = 127,           /* loop_statement  */
  YYSYMBOL_lvalue = 128,                   /* lvalue  */
  YYSYMBOL_expression = 129,               /* expression  */
  YYSYMBOL_list_of_expressions = 130,      /* list_of_expressions  */
  YYSYMBOL_string = 131,                   /* string  */
  YYSYMBOL_primary = 132,                  /* primary  */
  YYSYMBOL_number = 133,                   /* number  */
  YYSYMBOL_decimal_number = 134,           /* decimal_number  */
  YYSYMBOL_real_number = 135,              /* real_number  */
  YYSYMBOL_hierarchical_identifier = 136,  /* hierarchical_identifier  */
  YYSYMBOL_identifier = 137,               /* identifier  */
  YYSYMBOL_external_identifier = 138,      /* external_identifier  */
  YYSYMBOL_gate_instantiation = 139,       /* gate_instantiation  */
  YYSYMBOL_pull_gate_instance = 140,       /* pull_gate_instance  */
  YYSYMBOL_pulldown_strength = 141,        /* pulldown_strength  */
  YYSYMBOL_pullup_strength = 142,          /* pullup_strength  */
  YYSYMBOL_strength0 = 143,                /* strength0  */
  YYSYMBOL_strength1 = 144                 /* strength1  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   380

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  61
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  84
/* YYNRULES -- Number of rules.  */
#define YYNRULES  163
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  306

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   417


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    48,     2,    58,     2,    46,    41,     2,
      51,    52,    44,    42,    53,    43,    60,    45,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    55,    50,
       2,    57,     2,     2,    59,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    54,     2,    56,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    40,     2,    47,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     2,    18,     2,     2,     2,     2,     2,     2,
       2,    17,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    21,     2,     5,
       2,    11,     2,     2,    22,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    23,     2,
       2,     2,     2,     2,     2,    24,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    19,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    13,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       7,     8,     9,    10,    12,    15,    16,    14,    20,     6,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,     2,     2,    38,    39,     2,    49
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   216,   216,   219,   220,   224,   230,   230,   231,   234,
     237,   238,   242,   268,   269,   270,   271,   274,   279,   282,
     285,   294,   304,   309,   314,   317,   325,   329,   337,   345,
     353,   371,   376,   380,   381,   385,   390,   394,   395,   396,
     400,   401,   402,   403,   404,   405,   409,   417,   431,   432,
     436,   441,   445,   446,   449,   457,   458,   462,   466,   469,
     473,   477,   481,   485,   486,   490,   494,   498,   502,   506,
     510,   517,   536,   537,   538,   542,   551,   563,   567,   584,
     589,   596,   605,   609,   610,   617,   631,   644,   656,   657,
     658,   659,   660,   661,   662,   666,   667,   671,   673,   677,
     682,   690,   702,   723,   731,   746,   756,   765,   778,   785,
     796,   804,   816,   827,   828,   831,   839,   842,   845,   852,
     859,   868,   876,   882,   891,   892,   893,   901,   909,   917,
     925,   933,   941,   948,   955,   965,   970,   977,   987,   993,
    1000,  1001,  1004,  1005,  1006,  1015,  1024,  1034,  1037,  1045,
    1056,  1067,  1074,  1085,  1095,  1102,  1111,  1117,  1123,  1131,
    1137,  1143,  1150,  1153
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"system task identifier\"", "\"string\"", "\"unsigned number\"",
  "\"module\"", "\"endmodule\"", "\"input\"", "\"output\"", "\"inout\"",
  "\"reg\"", "\"always\"", "\"initial\"", "\"posedge\"", "\"negedge\"",
  "\"begin\"", "\"end\"", "\"<=\"", "\"wire\"", "\"assign\"", "\"if\"",
  "\"=>\"", "\"else\"", "\"`timescale\"", "\"supply0\"", "\"supply1\"",
  "\"pulldown\"", "\"pullup\"", "\"===\"", "\"!==\"", "\"==\"", "\"!=\"",
  "\"(*\"", "\"*)\"", "\"number\"", "\"forever\"", "\"specify\"",
  "\"endspecify\"", "'|'", "'&'", "'+'", "'-'", "'*'", "'/'", "'%'", "'~'",
  "'!'", "\"then\"", "';'", "'('", "')'", "','", "'['", "':'", "']'",
  "'='", "'#'", "'@'", "'.'", "$accept", "source_text", "directive_list",
  "timescale_compiler_directive", "description", "$@1", "attr_spec",
  "attr_list_opt", "module_declaration", "module_port_list_opt",
  "list_of_ports", "port", "port_reference", "port_identifier",
  "list_of_port_declarations", "range_opt", "port_declaration_head",
  "port_declaration", "module_item_list_opt", "module_item_list",
  "module_item", "module_or_generate_item", "module_instantiation",
  "module_instance", "list_of_port_connections_opt",
  "list_of_port_connections", "module_or_generate_item_declaration",
  "specify_block", "specify_item_list_opt", "specify_item_list",
  "specify_item", "path_declaration", "simple_path_declaration",
  "parallel_path_description", "path_delay_value",
  "list_of_path_delay_expressions", "path_delay_expression",
  "constant_expression", "constant_primary", "net_declaration", "net_type",
  "list_of_net_identifiers", "reg_declaration",
  "list_of_variable_identifiers", "variable_type", "continuous_assign",
  "list_of_net_assignments", "net_assignment", "always_construct",
  "initial_construct", "statement", "statement_or_null",
  "list_of_statements_opt", "list_of_statements", "conditional_statement",
  "system_task_enable", "system_function_call", "seq_block",
  "nonblocking_assignment", "blocking_assignment",
  "procedural_timing_control_statement", "delay_or_event_control",
  "delay_control", "delay_value", "event_control", "event_expression",
  "loop_statement", "lvalue", "expression", "list_of_expressions",
  "string", "primary", "number", "decimal_number", "real_number",
  "hierarchical_identifier", "identifier", "external_identifier",
  "gate_instantiation", "pull_gate_instance", "pulldown_strength",
  "pullup_strength", "strength0", "strength1", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-214)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-35)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -214,    30,    87,  -214,  -214,    20,  -214,  -214,  -214,    33,
      51,  -214,     5,    42,   118,  -214,    48,  -214,    62,  -214,
      94,   131,    14,    86,  -214,  -214,    84,     6,    84,  -214,
      -9,  -214,  -214,   121,  -214,  -214,   116,   195,    42,    84,
      42,    42,  -214,   118,  -214,   245,   135,   232,  -214,   -19,
     151,   139,  -214,  -214,  -214,  -214,  -214,   128,  -214,   195,
     195,   195,  -214,   299,  -214,  -214,  -214,  -214,  -214,   137,
    -214,  -214,  -214,    42,  -214,  -214,  -214,  -214,  -214,   118,
     163,   135,  -214,  -214,   160,   190,     9,    24,    24,  -214,
     118,  -214,  -214,    39,    53,  -214,  -214,  -214,    10,  -214,
    -214,  -214,  -214,   118,  -214,  -214,    42,  -214,  -214,   217,
    -214,  -214,  -214,   195,   195,   195,   195,   195,   195,   195,
     195,  -214,   226,  -214,  -214,  -214,    80,   195,    67,  -214,
    -214,   164,   148,   206,    24,   263,   225,  -214,  -214,  -214,
    -214,   244,   253,  -214,    18,  -214,  -214,  -214,     0,   250,
    -214,   108,  -214,   248,   115,   257,   260,    68,   115,   264,
      68,   195,   110,  -214,   270,   258,  -214,  -214,   191,   191,
     240,   166,  -214,  -214,   237,   255,   118,    26,  -214,  -214,
     268,  -214,  -214,  -214,   303,  -214,   118,  -214,   195,   118,
    -214,   308,    24,   195,  -214,  -214,  -214,  -214,   189,  -214,
    -214,  -214,  -214,  -214,    97,    97,   195,  -214,   118,   195,
    -214,  -214,   275,   210,   278,   118,  -214,   118,   285,   283,
     220,  -214,   287,   319,  -214,   118,  -214,   118,  -214,  -214,
    -214,   295,   296,    26,   195,  -214,   187,   235,    24,  -214,
    -214,   138,   195,   195,   300,   187,   195,   187,   195,   187,
     259,  -214,   187,  -214,  -214,   301,   325,   304,  -214,   301,
    -214,   325,  -214,   195,  -214,  -214,   239,  -214,  -214,  -214,
     276,   305,   195,   335,    18,   187,   187,  -214,   187,   187,
    -214,   311,   312,  -214,   313,   314,   282,  -214,   118,   118,
    -214,   187,  -214,   333,  -214,  -214,  -214,  -214,   118,  -214,
     114,    18,   169,  -214,  -214,  -214
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     6,     1,     8,     0,     3,     2,    11,     0,
       0,     7,     0,     0,     0,    10,     0,   149,    16,   148,
       0,     0,     0,     0,     9,     5,    26,    26,    26,    15,
       0,    18,    19,     0,    24,    20,    11,     0,     0,    26,
       0,     0,    14,     0,    13,     0,    56,     0,    32,     0,
       0,    11,    36,    37,    39,   105,   137,   145,   144,     0,
       0,     0,   141,     0,   125,   124,   140,   142,   143,   138,
     147,    27,    21,     0,    28,    29,    17,    23,    22,     0,
       0,    55,    58,    59,     0,     0,     0,     0,     0,    72,
       0,    73,    74,     0,     0,    45,    40,    52,     0,    53,
      43,    41,    42,     0,    44,    38,     0,    12,    35,     0,
     134,   132,   133,     0,     0,     0,     0,     0,     0,     0,
       0,    30,     0,    54,    57,    60,     0,     0,     0,    80,
      81,     0,    98,     0,     0,     0,     0,    86,    93,    92,
      91,     0,     0,    88,     0,   113,   114,    94,     0,   122,
      87,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,     0,    49,    31,   146,   130,   131,
     126,   127,   128,   129,     0,     0,     0,     0,    61,    63,
      65,    67,    68,    69,     0,    77,     0,   103,     0,     0,
     100,     0,    97,     0,   121,   145,   115,   116,     0,    89,
      90,    96,    95,   112,     0,     0,     0,    82,     0,     0,
     162,   163,     0,     0,     0,     0,   151,     0,     0,     0,
       0,   153,     0,     0,    70,     0,    46,     0,    47,    25,
     139,     0,     0,     0,     0,    79,   136,     0,    98,   106,
      99,     0,     0,     0,     0,   118,     0,   108,     0,   110,
       0,    84,    85,   155,   158,     0,     0,     0,   150,     0,
     161,     0,   152,     0,    75,    51,     0,    62,    64,    66,
       0,     0,     0,     0,     0,   119,   120,   117,   109,   111,
     123,     0,     0,   154,     0,     0,     0,    48,     0,     0,
     104,   135,   107,   101,   156,   157,   159,   160,     0,    50,
       0,     0,     0,    78,   102,    71
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -214,  -214,  -214,  -214,  -214,  -214,  -214,   359,  -214,  -214,
    -214,   326,  -213,   -25,  -214,   212,    77,  -214,  -214,  -214,
     317,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
     289,  -214,  -214,  -214,  -214,   194,   140,  -214,  -214,  -214,
    -214,    74,  -214,    88,   192,  -214,  -214,   167,  -214,  -214,
     -81,  -186,   141,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,    60,  -214,  -214,  -214,  -214,  -214,   -80,   -22,  -214,
    -214,  -214,  -125,   241,  -214,   -85,   -14,   367,  -214,   -90,
    -214,  -214,  -147,  -149
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,     6,     7,     8,    15,    47,    11,    23,
      30,    31,    32,    71,    33,    38,    48,    49,    50,    51,
      52,    53,    95,   164,   228,   266,    96,    54,    80,    81,
      82,    83,    84,    85,   178,   179,   180,   181,   182,    97,
      98,   162,    99,   128,   129,   100,   151,   152,   101,   102,
     202,   203,   191,   192,   138,   139,    62,   140,   141,   142,
     143,   144,   145,   196,   146,   244,   147,   148,    63,   237,
      64,    65,    66,    67,    68,    69,    70,    72,   104,   156,
     157,   160,   213,   214
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      20,   183,   149,   149,   159,   149,   137,   150,    35,   220,
     153,   219,    19,    19,   265,    74,    75,    19,    39,   204,
      77,    19,   131,    26,    27,    28,     9,    19,   131,    35,
       3,   105,    57,   103,   106,   132,    12,   110,   111,   112,
     133,   132,    19,    42,    43,    17,   133,   149,   121,   149,
      16,   190,   183,   194,    21,   134,    19,   205,    13,   149,
      37,   134,    58,   127,   161,   122,    29,   218,   201,   149,
     222,    19,   130,   149,   212,   299,   135,   136,   212,   155,
     155,   166,   135,   136,   163,    14,    57,     4,   293,   165,
     154,   168,   169,   170,   171,   172,   173,   174,   175,    34,
      19,    55,    56,    57,   158,   184,   281,   149,   183,   282,
     284,   240,     5,    22,   285,   304,    58,   185,    19,   217,
     186,    19,    78,   149,   -34,    26,    27,    28,   153,    24,
     149,   177,   149,    58,    25,   257,    36,   212,    37,   223,
      59,   210,   211,   155,    60,    61,   155,   -33,    26,    27,
      28,    19,   131,   149,    46,   135,   136,   190,   207,   107,
     224,   208,   231,   225,   303,   132,   236,   186,   113,   114,
     133,   241,   130,    44,    45,   238,   245,    46,   115,   116,
     117,   118,   247,   249,   250,   134,    79,   252,   109,   149,
     274,   120,    19,    55,    56,    57,   113,   114,    19,    55,
      56,    57,   123,   189,   242,   243,   135,   136,   117,   118,
     125,   264,   270,    35,   187,   188,   149,   113,   114,   305,
     275,   276,   225,   167,   278,    58,   279,   115,   116,   117,
     118,    58,    59,   117,   118,    19,    60,    61,    59,    40,
      41,   286,    60,    61,    86,    87,    88,   126,    17,   176,
     291,    73,    89,    90,    26,    27,    28,   193,    91,    92,
      93,    94,   254,   255,   246,   248,    14,   113,   114,   195,
     113,   114,   260,   261,    35,   130,   198,   115,   116,   117,
     118,   116,   117,   118,   163,   113,   114,   271,   272,   113,
     114,   287,   288,   229,   199,   115,   116,   117,   118,   115,
     116,   117,   118,   200,   206,   209,   113,   114,   215,   227,
     216,   230,   113,   114,   221,   280,   115,   116,   117,   118,
     226,   233,   115,   116,   117,   118,   239,   253,   211,   113,
     114,   256,   289,   113,   114,   258,   259,   262,   298,   115,
     116,   117,   118,   115,   116,   117,   118,   267,   268,   113,
     114,   210,   277,   292,   119,   290,   283,   301,   234,   115,
     116,   117,   118,   294,   295,   296,   297,    10,   108,    76,
     124,   232,   302,   269,   263,   251,   197,   300,   235,   273,
      18
};

static const yytype_int16 yycheck[] =
{
      14,   126,    87,    88,    94,    90,    87,    88,    22,   158,
      90,   158,     3,     3,   227,    40,    41,     3,    12,    19,
      45,     3,     4,     9,    10,    11,     6,     3,     4,    43,
       0,    50,     6,    47,    53,    17,     3,    59,    60,    61,
      22,    17,     3,    52,    53,     3,    22,   132,    73,   134,
      45,   132,   177,   134,     6,    37,     3,    57,     7,   144,
      54,    37,    36,    54,    54,    79,    52,   157,    50,   154,
     160,     3,    86,   158,   154,   288,    58,    59,   158,    93,
      94,   106,    58,    59,    98,    34,     6,     0,   274,   103,
      51,   113,   114,   115,   116,   117,   118,   119,   120,    22,
       3,     4,     5,     6,    51,   127,   255,   192,   233,   256,
     259,   192,    25,    51,   261,   301,    36,    50,     3,    51,
      53,     3,    45,   208,     8,     9,    10,    11,   208,    35,
     215,    51,   217,    36,     3,   215,    50,   217,    54,   161,
      43,    26,    27,   157,    47,    48,   160,     8,     9,    10,
      11,     3,     4,   238,    38,    58,    59,   238,    50,     8,
      50,    53,   176,    53,    50,    17,   188,    53,    30,    31,
      22,   193,   186,    52,    53,   189,   198,    38,    40,    41,
      42,    43,   204,   205,   206,    37,    51,   209,    60,   274,
      52,    54,     3,     4,     5,     6,    30,    31,     3,     4,
       5,     6,    39,    55,    15,    16,    58,    59,    42,    43,
      50,   225,   234,   227,    50,    51,   301,    30,    31,    50,
     242,   243,    53,     6,   246,    36,   248,    40,    41,    42,
      43,    36,    43,    42,    43,     3,    47,    48,    43,    27,
      28,   263,    47,    48,    12,    13,    14,    57,     3,    23,
     272,    39,    20,    21,     9,    10,    11,    51,    26,    27,
      28,    29,    52,    53,   204,   205,    34,    30,    31,     6,
      30,    31,    52,    53,   288,   289,    51,    40,    41,    42,
      43,    41,    42,    43,   298,    30,    31,    52,    53,    30,
      31,    52,    53,    56,    50,    40,    41,    42,    43,    40,
      41,    42,    43,    50,    54,    57,    30,    31,    51,    51,
      50,    56,    30,    31,    50,    56,    40,    41,    42,    43,
      50,    53,    40,    41,    42,    43,    18,    52,    27,    30,
      31,    53,    56,    30,    31,    50,    53,    50,    56,    40,
      41,    42,    43,    40,    41,    42,    43,    52,    52,    30,
      31,    26,    52,    18,    55,    50,    52,    24,    55,    40,
      41,    42,    43,    52,    52,    52,    52,     8,    51,    43,
      81,   177,   298,   233,    55,   208,   135,   289,   186,   238,
      13
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    62,    63,     0,     0,    25,    64,    65,    66,     6,
      68,    69,     3,     7,    34,    67,    45,     3,   138,     3,
     137,     6,    51,    70,    35,     3,     9,    10,    11,    52,
      71,    72,    73,    75,    77,   137,    50,    54,    76,    12,
      76,    76,    52,    53,    52,    53,    38,    68,    77,    78,
      79,    80,    81,    82,    88,     4,     5,     6,    36,    43,
      47,    48,   117,   129,   131,   132,   133,   134,   135,   136,
     137,    74,   138,    76,    74,    74,    72,    74,    77,    51,
      89,    90,    91,    92,    93,    94,    12,    13,    14,    20,
      21,    26,    27,    28,    29,    83,    87,   100,   101,   103,
     106,   109,   110,   137,   139,    50,    53,     8,    81,    60,
     129,   129,   129,    30,    31,    40,    41,    42,    43,    55,
      54,    74,   137,    39,    91,    50,    57,    54,   104,   105,
     137,     4,    17,    22,    37,    58,    59,   111,   115,   116,
     118,   119,   120,   121,   122,   123,   125,   127,   128,   136,
     111,   107,   108,   128,    51,   137,   140,   141,    51,   140,
     142,    54,   102,   137,    84,   137,    74,     6,   129,   129,
     129,   129,   129,   129,   129,   129,    23,    51,    95,    96,
      97,    98,    99,   133,   129,    50,    53,    50,    51,    55,
     111,   113,   114,    51,   111,     6,   124,   134,    51,    50,
      50,    50,   111,   112,    19,    57,    54,    50,    53,    57,
      26,    27,   128,   143,   144,    51,    50,    51,   140,   143,
     144,    50,   140,   129,    50,    53,    50,    51,    85,    56,
      56,   137,    96,    53,    55,   105,   129,   130,   137,    18,
     111,   129,    15,    16,   126,   129,   122,   129,   122,   129,
     129,   108,   129,    52,    52,    53,    53,   128,    50,    53,
      52,    53,    50,    55,   137,    73,    86,    52,    52,    97,
     129,    52,    53,   113,    52,   129,   129,    52,   129,   129,
      56,   144,   143,    52,   144,   143,   129,    52,    53,    56,
      50,   129,    18,   112,    52,    52,    52,    52,    56,    73,
     104,    24,   102,    50,   112,    50
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    61,    62,    63,    63,    64,    66,    65,    65,    67,
      68,    68,    69,    70,    70,    70,    70,    71,    71,    72,
      73,    74,    75,    75,    75,    76,    76,    77,    77,    77,
      77,    78,    78,    79,    79,    80,    80,    81,    81,    81,
      82,    82,    82,    82,    82,    82,    83,    84,    85,    85,
      86,    86,    87,    87,    88,    89,    89,    90,    90,    91,
      92,    93,    94,    95,    95,    96,    96,    97,    98,    99,
     100,   100,   101,   101,   101,   102,   102,   103,   103,   104,
     104,   105,   106,   107,   107,   108,   109,   110,   111,   111,
     111,   111,   111,   111,   111,   112,   112,   113,   113,   114,
     114,   115,   115,   116,   116,   117,   118,   118,   119,   119,
     120,   120,   121,   122,   122,   123,   124,   125,   126,   126,
     126,   127,   128,   128,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   130,   130,   131,   132,   132,
     132,   132,   133,   133,   133,   134,   135,   136,   137,   138,
     139,   139,   139,   139,   140,   140,   141,   141,   141,   142,
     142,   142,   143,   144
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     0,     6,     0,     2,     1,     3,
       2,     0,     7,     3,     3,     2,     0,     3,     1,     1,
       1,     1,     3,     3,     1,     5,     0,     3,     3,     3,
       4,     3,     1,     1,     0,     2,     1,     1,     2,     1,
       2,     2,     2,     2,     2,     2,     3,     2,     3,     0,
       3,     1,     1,     1,     3,     1,     0,     2,     1,     1,
       2,     3,     5,     1,     3,     1,     3,     1,     1,     1,
       3,     8,     1,     1,     1,     3,     1,     3,     8,     3,
       1,     1,     3,     1,     3,     3,     2,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       1,     5,     7,     2,     5,     1,     3,     5,     3,     4,
       3,     4,     2,     1,     1,     2,     1,     4,     1,     2,
       2,     2,     1,     4,     1,     1,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     3,     1,     1,     1,     4,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       4,     3,     4,     3,     4,     3,     5,     5,     3,     5,
       5,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= tEOF)
    {
      yychar = tEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 5: /* timescale_compiler_directive: "`timescale" "unsigned number" "identifier" '/' "unsigned number" "identifier"  */
#line 225 "../src/vlog/vlog-parse.y"
                {
                   set_timescale((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-1].str), (yyvsp[0].str), &(yyloc));
                }
#line 2053 "../src/vlog/vlog-parse.c"
    break;

  case 6: /* $@1: %empty  */
#line 230 "../src/vlog/vlog-parse.y"
                { root = vlog_new(V_MODULE); }
#line 2059 "../src/vlog/vlog-parse.c"
    break;

  case 7: /* description: $@1 module_declaration  */
#line 230 "../src/vlog/vlog-parse.y"
                                                                  { YYACCEPT; }
#line 2065 "../src/vlog/vlog-parse.c"
    break;

  case 8: /* description: "end of file"  */
#line 231 "../src/vlog/vlog-parse.y"
                     { root = NULL; }
#line 2071 "../src/vlog/vlog-parse.c"
    break;

  case 12: /* module_declaration: attr_list_opt "module" external_identifier module_port_list_opt ';' module_item_list_opt "endmodule"  */
#line 244 "../src/vlog/vlog-parse.y"
                {
                   ident_t qual = ident_prefix(lib_name(lib_work()),
                                               (yyvsp[-4].pair).right, '.');

                   (yyval.vlog) = root;
                   vlog_set_ident((yyval.vlog), qual);
                   vlog_set_ident2((yyval.vlog), (yyvsp[-4].pair).left);
                   vlog_set_loc((yyval.vlog), &(yyloc));

                   for (node_list_t *it = (yyvsp[-3].list); it; it = it->next)
                      add_port((yyval.vlog), it->value);
                   node_list_free((yyvsp[-3].list));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next) {
                      if (is_decl(it->value))
                         vlog_add_decl((yyval.vlog), it->value);
                      else
                         vlog_add_stmt((yyval.vlog), it->value);
                   }
                   node_list_free((yyvsp[-1].list));
                }
#line 2097 "../src/vlog/vlog-parse.c"
    break;

  case 13: /* module_port_list_opt: '(' list_of_port_declarations ')'  */
#line 268 "../src/vlog/vlog-parse.y"
                                                  { (yyval.list) = (yyvsp[-1].list); }
#line 2103 "../src/vlog/vlog-parse.c"
    break;

  case 14: /* module_port_list_opt: '(' list_of_ports ')'  */
#line 269 "../src/vlog/vlog-parse.y"
                                      { (yyval.list) = (yyvsp[-1].list); }
#line 2109 "../src/vlog/vlog-parse.c"
    break;

  case 15: /* module_port_list_opt: '(' ')'  */
#line 270 "../src/vlog/vlog-parse.y"
                        { (yyval.list) = NULL; }
#line 2115 "../src/vlog/vlog-parse.c"
    break;

  case 16: /* module_port_list_opt: %empty  */
#line 271 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2121 "../src/vlog/vlog-parse.c"
    break;

  case 17: /* list_of_ports: list_of_ports ',' port  */
#line 275 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2130 "../src/vlog/vlog-parse.c"
    break;

  case 18: /* list_of_ports: port  */
#line 279 "../src/vlog/vlog-parse.y"
                     { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2136 "../src/vlog/vlog-parse.c"
    break;

  case 19: /* port: port_reference  */
#line 282 "../src/vlog/vlog-parse.y"
                               { (yyval.vlog) = (yyvsp[0].vlog); }
#line 2142 "../src/vlog/vlog-parse.c"
    break;

  case 20: /* port_reference: identifier  */
#line 286 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2152 "../src/vlog/vlog-parse.c"
    break;

  case 21: /* port_identifier: external_identifier  */
#line 295 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_PORT_DECL);
                   vlog_set_loc((yyval.vlog), &(yylsp[0]));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].pair).left);
                   vlog_set_ident2((yyval.vlog), (yyvsp[0].pair).right);
                }
#line 2163 "../src/vlog/vlog-parse.c"
    break;

  case 22: /* list_of_port_declarations: list_of_port_declarations ',' port_declaration_head  */
#line 305 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_concat(&(yyval.list), (yyvsp[0].list));
                }
#line 2172 "../src/vlog/vlog-parse.c"
    break;

  case 23: /* list_of_port_declarations: list_of_port_declarations ',' port_identifier  */
#line 310 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   clone_port(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2181 "../src/vlog/vlog-parse.c"
    break;

  case 24: /* list_of_port_declarations: port_declaration_head  */
#line 314 "../src/vlog/vlog-parse.y"
                                      { (yyval.list) = (yyvsp[0].list); }
#line 2187 "../src/vlog/vlog-parse.c"
    break;

  case 25: /* range_opt: '[' expression ':' expression ']'  */
#line 318 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_DIMENSION);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_DIM_PACKED);
                   vlog_set_left((yyval.vlog), (yyvsp[-3].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[-1].vlog));
                }
#line 2199 "../src/vlog/vlog-parse.c"
    break;

  case 26: /* range_opt: %empty  */
#line 325 "../src/vlog/vlog-parse.y"
                            { (yyval.vlog) = NULL; }
#line 2205 "../src/vlog/vlog-parse.c"
    break;

  case 27: /* port_declaration_head: "input" range_opt port_identifier  */
#line 330 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_INPUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = node_list_single((yyvsp[0].vlog));
                }
#line 2217 "../src/vlog/vlog-parse.c"
    break;

  case 28: /* port_declaration_head: "output" range_opt port_identifier  */
#line 338 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_OUTPUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = node_list_single((yyvsp[0].vlog));
                }
#line 2229 "../src/vlog/vlog-parse.c"
    break;

  case 29: /* port_declaration_head: "inout" range_opt port_identifier  */
#line 346 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_INOUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = node_list_single((yyvsp[0].vlog));
                }
#line 2241 "../src/vlog/vlog-parse.c"
    break;

  case 30: /* port_declaration_head: "output" "reg" range_opt port_identifier  */
#line 354 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_OUTPUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));

                   vlog_node_t reg = vlog_new(V_VAR_DECL);
                   vlog_set_loc(reg, &(yyloc));
                   vlog_set_ident(reg, vlog_ident((yyvsp[0].vlog)));

                   node_list_append(&(yyval.list), reg);
                }
#line 2260 "../src/vlog/vlog-parse.c"
    break;

  case 31: /* port_declaration: port_declaration ',' port_identifier  */
#line 372 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   clone_port(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2269 "../src/vlog/vlog-parse.c"
    break;

  case 34: /* module_item_list_opt: %empty  */
#line 381 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2275 "../src/vlog/vlog-parse.c"
    break;

  case 35: /* module_item_list: module_item_list module_item  */
#line 386 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                   node_list_concat(&(yyval.list), (yyvsp[0].list));
                }
#line 2284 "../src/vlog/vlog-parse.c"
    break;

  case 39: /* module_item: specify_block  */
#line 396 "../src/vlog/vlog-parse.y"
                              { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2290 "../src/vlog/vlog-parse.c"
    break;

  case 40: /* module_or_generate_item: attr_list_opt module_or_generate_item_declaration  */
#line 400 "../src/vlog/vlog-parse.y"
                                                                  { (yyval.list) = (yyvsp[0].list); }
#line 2296 "../src/vlog/vlog-parse.c"
    break;

  case 41: /* module_or_generate_item: attr_list_opt always_construct  */
#line 401 "../src/vlog/vlog-parse.y"
                                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2302 "../src/vlog/vlog-parse.c"
    break;

  case 42: /* module_or_generate_item: attr_list_opt initial_construct  */
#line 402 "../src/vlog/vlog-parse.y"
                                                { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2308 "../src/vlog/vlog-parse.c"
    break;

  case 43: /* module_or_generate_item: attr_list_opt continuous_assign  */
#line 403 "../src/vlog/vlog-parse.y"
                                                { (yyval.list) = (yyvsp[0].list); }
#line 2314 "../src/vlog/vlog-parse.c"
    break;

  case 44: /* module_or_generate_item: attr_list_opt gate_instantiation  */
#line 404 "../src/vlog/vlog-parse.y"
                                                 { (yyval.list) = (yyvsp[0].list); }
#line 2320 "../src/vlog/vlog-parse.c"
    break;

  case 45: /* module_or_generate_item: attr_list_opt module_instantiation  */
#line 405 "../src/vlog/vlog-parse.y"
                                                   { (yyval.list) = (yyvsp[0].list); }
#line 2326 "../src/vlog/vlog-parse.c"
    break;

  case 46: /* module_instantiation: identifier module_instance ';'  */
#line 410 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_ident2((yyvsp[-1].vlog), (yyvsp[-2].ident));
                   (yyval.list) = node_list_single((yyvsp[-1].vlog));
                }
#line 2335 "../src/vlog/vlog-parse.c"
    break;

  case 47: /* module_instance: identifier list_of_port_connections_opt  */
#line 418 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_MOD_INST);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-1].ident));

                   for (node_list_t *it = (yyvsp[0].list); it; it = it->next)
                      vlog_add_param((yyval.vlog), it->value);

                   node_list_free((yyvsp[0].list));
                }
#line 2350 "../src/vlog/vlog-parse.c"
    break;

  case 48: /* list_of_port_connections_opt: '(' list_of_port_connections ')'  */
#line 431 "../src/vlog/vlog-parse.y"
                                                 { (yyval.list) = (yyvsp[-1].list); }
#line 2356 "../src/vlog/vlog-parse.c"
    break;

  case 49: /* list_of_port_connections_opt: %empty  */
#line 432 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2362 "../src/vlog/vlog-parse.c"
    break;

  case 50: /* list_of_port_connections: list_of_port_connections ',' port_reference  */
#line 437 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2371 "../src/vlog/vlog-parse.c"
    break;

  case 51: /* list_of_port_connections: port_reference  */
#line 441 "../src/vlog/vlog-parse.y"
                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2377 "../src/vlog/vlog-parse.c"
    break;

  case 54: /* specify_block: "specify" specify_item_list_opt "endspecify"  */
#line 450 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SPECIFY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 2386 "../src/vlog/vlog-parse.c"
    break;

  case 56: /* specify_item_list_opt: %empty  */
#line 458 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2392 "../src/vlog/vlog-parse.c"
    break;

  case 57: /* specify_item_list: specify_item_list specify_item  */
#line 463 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                }
#line 2400 "../src/vlog/vlog-parse.c"
    break;

  case 58: /* specify_item_list: specify_item  */
#line 466 "../src/vlog/vlog-parse.y"
                             { (yyval.list) = NULL; }
#line 2406 "../src/vlog/vlog-parse.c"
    break;

  case 70: /* net_declaration: net_type list_of_net_identifiers ';'  */
#line 511 "../src/vlog/vlog-parse.y"
                {
                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_set_subkind(it->value, (yyvsp[-2].kind));

                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2417 "../src/vlog/vlog-parse.c"
    break;

  case 71: /* net_declaration: net_type '[' expression ':' expression ']' list_of_net_identifiers ';'  */
#line 519 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t r = vlog_new(V_DIMENSION);
                   vlog_set_loc(r, &(yyloc));
                   vlog_set_subkind(r, V_DIM_PACKED);
                   vlog_set_left(r, (yyvsp[-5].vlog));
                   vlog_set_right(r, (yyvsp[-3].vlog));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next) {
                      vlog_add_range(it->value, r);
                      vlog_set_datatype(it->value, DT_LOGIC);
                      vlog_set_subkind(it->value, (yyvsp[-7].kind));
                   }

                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2437 "../src/vlog/vlog-parse.c"
    break;

  case 72: /* net_type: "wire"  */
#line 536 "../src/vlog/vlog-parse.y"
                      { (yyval.kind) = V_NET_WIRE; }
#line 2443 "../src/vlog/vlog-parse.c"
    break;

  case 73: /* net_type: "supply0"  */
#line 537 "../src/vlog/vlog-parse.y"
                         { (yyval.kind) = V_NET_SUPPLY0; }
#line 2449 "../src/vlog/vlog-parse.c"
    break;

  case 74: /* net_type: "supply1"  */
#line 538 "../src/vlog/vlog-parse.y"
                         { (yyval.kind) = V_NET_SUPPLY1; }
#line 2455 "../src/vlog/vlog-parse.c"
    break;

  case 75: /* list_of_net_identifiers: list_of_net_identifiers ',' identifier  */
#line 543 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t v = vlog_new(V_NET_DECL);
                   vlog_set_loc(v, &(yylsp[0]));
                   vlog_set_ident(v, (yyvsp[0].ident));

                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), v);
                }
#line 2468 "../src/vlog/vlog-parse.c"
    break;

  case 76: /* list_of_net_identifiers: identifier  */
#line 552 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t v = vlog_new(V_NET_DECL);
                   vlog_set_loc(v, &(yyloc));
                   vlog_set_ident(v, (yyvsp[0].ident));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), v);
                }
#line 2481 "../src/vlog/vlog-parse.c"
    break;

  case 77: /* reg_declaration: "reg" list_of_variable_identifiers ';'  */
#line 564 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2489 "../src/vlog/vlog-parse.c"
    break;

  case 78: /* reg_declaration: "reg" '[' expression ':' expression ']' list_of_variable_identifiers ';'  */
#line 569 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t r = vlog_new(V_DIMENSION);
                   vlog_set_loc(r, &(yyloc));
                   vlog_set_subkind(r, V_DIM_PACKED);
                   vlog_set_left(r, (yyvsp[-5].vlog));
                   vlog_set_right(r, (yyvsp[-3].vlog));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_range(it->value, r);

                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2506 "../src/vlog/vlog-parse.c"
    break;

  case 79: /* list_of_variable_identifiers: list_of_variable_identifiers ',' variable_type  */
#line 585 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2515 "../src/vlog/vlog-parse.c"
    break;

  case 80: /* list_of_variable_identifiers: variable_type  */
#line 590 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2524 "../src/vlog/vlog-parse.c"
    break;

  case 81: /* variable_type: identifier  */
#line 597 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_VAR_DECL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2534 "../src/vlog/vlog-parse.c"
    break;

  case 82: /* continuous_assign: "assign" list_of_net_assignments ';'  */
#line 605 "../src/vlog/vlog-parse.y"
                                                    { (yyval.list) = (yyvsp[-1].list); }
#line 2540 "../src/vlog/vlog-parse.c"
    break;

  case 83: /* list_of_net_assignments: net_assignment  */
#line 609 "../src/vlog/vlog-parse.y"
                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2546 "../src/vlog/vlog-parse.c"
    break;

  case 84: /* list_of_net_assignments: list_of_net_assignments ',' net_assignment  */
#line 611 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2555 "../src/vlog/vlog-parse.c"
    break;

  case 85: /* net_assignment: lvalue '=' expression  */
#line 618 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_ASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__assign#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2570 "../src/vlog/vlog-parse.c"
    break;

  case 86: /* always_construct: "always" statement  */
#line 632 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_ALWAYS);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__always#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2584 "../src/vlog/vlog-parse.c"
    break;

  case 87: /* initial_construct: "initial" statement  */
#line 645 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_INITIAL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__initial#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2598 "../src/vlog/vlog-parse.c"
    break;

  case 96: /* statement_or_null: ';'  */
#line 667 "../src/vlog/vlog-parse.y"
                    { (yyval.vlog) = NULL; }
#line 2604 "../src/vlog/vlog-parse.c"
    break;

  case 98: /* list_of_statements_opt: %empty  */
#line 673 "../src/vlog/vlog-parse.y"
                { (yyval.list) = NULL; }
#line 2610 "../src/vlog/vlog-parse.c"
    break;

  case 99: /* list_of_statements: list_of_statements statement  */
#line 678 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2619 "../src/vlog/vlog-parse.c"
    break;

  case 100: /* list_of_statements: statement  */
#line 683 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2628 "../src/vlog/vlog-parse.c"
    break;

  case 101: /* conditional_statement: "if" '(' expression ')' statement_or_null  */
#line 691 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t c = vlog_new(V_COND);
                   vlog_set_loc(c, &(yylsp[-2]));
                   vlog_set_value(c, (yyvsp[-2].vlog));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt(c, (yyvsp[0].vlog));

                   (yyval.vlog) = vlog_new(V_IF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_cond((yyval.vlog), c);
                }
#line 2644 "../src/vlog/vlog-parse.c"
    break;

  case 102: /* conditional_statement: "if" '(' expression ')' statement_or_null "else" statement_or_null  */
#line 703 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t c1 = vlog_new(V_COND);
                   vlog_set_loc(c1, &(yylsp[-4]));
                   vlog_set_value(c1, (yyvsp[-4].vlog));
                   if ((yyvsp[-2].vlog) != NULL)
                      vlog_add_stmt(c1, (yyvsp[-2].vlog));

                   vlog_node_t c2 = vlog_new(V_COND);
                   vlog_set_loc(c2, &(yylsp[-1]));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt(c2, (yyvsp[0].vlog));

                   (yyval.vlog) = vlog_new(V_IF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_cond((yyval.vlog), c1);
                   vlog_add_cond((yyval.vlog), c2);
                }
#line 2666 "../src/vlog/vlog-parse.c"
    break;

  case 103: /* system_task_enable: "system task identifier" ';'  */
#line 724 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSTASK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[-1].str)));

                   free((yyvsp[-1].str));
                }
#line 2678 "../src/vlog/vlog-parse.c"
    break;

  case 104: /* system_task_enable: "system task identifier" '(' list_of_expressions ')' ';'  */
#line 732 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSTASK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[-4].str)));

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyval.vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   free((yyvsp[-4].str));
                }
#line 2694 "../src/vlog/vlog-parse.c"
    break;

  case 105: /* system_function_call: "system task identifier"  */
#line 747 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSFUNC);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[0].str)));

                   free((yyvsp[0].str));
                }
#line 2706 "../src/vlog/vlog-parse.c"
    break;

  case 106: /* seq_block: "begin" list_of_statements_opt "end"  */
#line 757 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SEQ_BLOCK);
                   vlog_set_loc((yyval.vlog), &(yyloc));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_stmt((yyval.vlog), it->value);
                   node_list_free((yyvsp[-1].list));
                }
#line 2719 "../src/vlog/vlog-parse.c"
    break;

  case 107: /* seq_block: "begin" ':' identifier list_of_statements_opt "end"  */
#line 766 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SEQ_BLOCK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-2].ident));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_stmt((yyval.vlog), it->value);
                   node_list_free((yyvsp[-1].list));
                }
#line 2733 "../src/vlog/vlog-parse.c"
    break;

  case 108: /* nonblocking_assignment: lvalue "<=" expression  */
#line 779 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NBASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2744 "../src/vlog/vlog-parse.c"
    break;

  case 109: /* nonblocking_assignment: lvalue "<=" delay_or_event_control expression  */
#line 786 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NBASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-3].vlog));
                   vlog_set_delay((yyval.vlog), (yyvsp[-1].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2756 "../src/vlog/vlog-parse.c"
    break;

  case 110: /* blocking_assignment: lvalue '=' expression  */
#line 797 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_ASSIGN_EQUALS);
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2768 "../src/vlog/vlog-parse.c"
    break;

  case 111: /* blocking_assignment: lvalue '=' delay_or_event_control expression  */
#line 805 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_ASSIGN_EQUALS);
                   vlog_set_target((yyval.vlog), (yyvsp[-3].vlog));
                   vlog_set_delay((yyval.vlog), (yyvsp[-1].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2781 "../src/vlog/vlog-parse.c"
    break;

  case 112: /* procedural_timing_control_statement: delay_or_event_control statement_or_null  */
#line 817 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_TIMING);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_value((yyval.vlog), (yyvsp[-1].vlog));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2793 "../src/vlog/vlog-parse.c"
    break;

  case 115: /* delay_control: '#' delay_value  */
#line 832 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_DELAY_CONTROL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2803 "../src/vlog/vlog-parse.c"
    break;

  case 117: /* event_control: '@' '(' event_expression ')'  */
#line 842 "../src/vlog/vlog-parse.y"
                                            { (yyval.vlog) = (yyvsp[-1].vlog); }
#line 2809 "../src/vlog/vlog-parse.c"
    break;

  case 118: /* event_expression: expression  */
#line 846 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_LEVEL);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2820 "../src/vlog/vlog-parse.c"
    break;

  case 119: /* event_expression: "posedge" expression  */
#line 853 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_POSEDGE);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2831 "../src/vlog/vlog-parse.c"
    break;

  case 120: /* event_expression: "negedge" expression  */
#line 860 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_NEGEDGE);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2842 "../src/vlog/vlog-parse.c"
    break;

  case 121: /* loop_statement: "forever" statement  */
#line 869 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_FOREVER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2852 "../src/vlog/vlog-parse.c"
    break;

  case 122: /* lvalue: hierarchical_identifier  */
#line 877 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2862 "../src/vlog/vlog-parse.c"
    break;

  case 123: /* lvalue: hierarchical_identifier '[' expression ']'  */
#line 883 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BIT_SELECT);
                   vlog_set_ident((yyval.vlog), (yyvsp[-3].ident));
                   vlog_add_param((yyval.vlog), (yyvsp[-1].vlog));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 2873 "../src/vlog/vlog-parse.c"
    break;

  case 126: /* expression: expression '|' expression  */
#line 894 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_OR);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2885 "../src/vlog/vlog-parse.c"
    break;

  case 127: /* expression: expression '&' expression  */
#line 902 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_AND);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2897 "../src/vlog/vlog-parse.c"
    break;

  case 128: /* expression: expression '+' expression  */
#line 910 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_PLUS);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2909 "../src/vlog/vlog-parse.c"
    break;

  case 129: /* expression: expression '-' expression  */
#line 918 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_MINUS);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2921 "../src/vlog/vlog-parse.c"
    break;

  case 130: /* expression: expression "===" expression  */
#line 926 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_CASE_EQ);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2933 "../src/vlog/vlog-parse.c"
    break;

  case 131: /* expression: expression "!==" expression  */
#line 934 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_CASE_NEQ);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2945 "../src/vlog/vlog-parse.c"
    break;

  case 132: /* expression: '~' expression  */
#line 942 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_UNARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_UNARY_BITNEG);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2956 "../src/vlog/vlog-parse.c"
    break;

  case 133: /* expression: '!' expression  */
#line 949 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_UNARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_UNARY_NOT);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2967 "../src/vlog/vlog-parse.c"
    break;

  case 134: /* expression: '-' expression  */
#line 956 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_UNARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_UNARY_NEG);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2978 "../src/vlog/vlog-parse.c"
    break;

  case 135: /* list_of_expressions: list_of_expressions ',' expression  */
#line 966 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2987 "../src/vlog/vlog-parse.c"
    break;

  case 136: /* list_of_expressions: expression  */
#line 971 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2996 "../src/vlog/vlog-parse.c"
    break;

  case 137: /* string: "string"  */
#line 978 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_STRING);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   (yyvsp[0].str)[strlen((yyvsp[0].str)) - 1] = '\0';
                   vlog_set_text((yyval.vlog), (yyvsp[0].str) + 1);
                   free((yyvsp[0].str));
                }
#line 3008 "../src/vlog/vlog-parse.c"
    break;

  case 138: /* primary: hierarchical_identifier  */
#line 988 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 3018 "../src/vlog/vlog-parse.c"
    break;

  case 139: /* primary: hierarchical_identifier '[' expression ']'  */
#line 994 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BIT_SELECT);
                   vlog_set_ident((yyval.vlog), (yyvsp[-3].ident));
                   vlog_add_param((yyval.vlog), (yyvsp[-1].vlog));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 3029 "../src/vlog/vlog-parse.c"
    break;

  case 144: /* number: "number"  */
#line 1007 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NUMBER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_number((yyval.vlog), number_new((yyvsp[0].str)));
                   free((yyvsp[0].str));
                }
#line 3040 "../src/vlog/vlog-parse.c"
    break;

  case 145: /* decimal_number: "unsigned number"  */
#line 1016 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NUMBER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_number((yyval.vlog), number_new((yyvsp[0].str)));
                   free((yyvsp[0].str));
                }
#line 3051 "../src/vlog/vlog-parse.c"
    break;

  case 146: /* real_number: "unsigned number" '.' "unsigned number"  */
#line 1025 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NUMBER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   free((yyvsp[-2].str));
                   free((yyvsp[0].str));
                }
#line 3062 "../src/vlog/vlog-parse.c"
    break;

  case 148: /* identifier: "identifier"  */
#line 1038 "../src/vlog/vlog-parse.y"
                {
                   (yyval.ident) = ident_new((yyvsp[0].str));
                   free((yyvsp[0].str));
                }
#line 3071 "../src/vlog/vlog-parse.c"
    break;

  case 149: /* external_identifier: "identifier"  */
#line 1046 "../src/vlog/vlog-parse.y"
                {
                   (yyval.pair).left = ident_new((yyvsp[0].str));
                   for (char *p = (yyvsp[0].str); *p; p++)
                      *p = toupper_iso88591(*p);
                   (yyval.pair).right = ident_new((yyvsp[0].str));
                   free((yyvsp[0].str));
                }
#line 3083 "../src/vlog/vlog-parse.c"
    break;

  case 150: /* gate_instantiation: "pulldown" pulldown_strength pull_gate_instance ';'  */
#line 1057 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLDOWN);

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyvsp[-1].vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3098 "../src/vlog/vlog-parse.c"
    break;

  case 151: /* gate_instantiation: "pulldown" pull_gate_instance ';'  */
#line 1068 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLDOWN);

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3109 "../src/vlog/vlog-parse.c"
    break;

  case 152: /* gate_instantiation: "pullup" pullup_strength pull_gate_instance ';'  */
#line 1075 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLUP);

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyvsp[-1].vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3124 "../src/vlog/vlog-parse.c"
    break;

  case 153: /* gate_instantiation: "pullup" pull_gate_instance ';'  */
#line 1086 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLUP);

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3135 "../src/vlog/vlog-parse.c"
    break;

  case 154: /* pull_gate_instance: identifier '(' lvalue ')'  */
#line 1096 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_GATE_INST);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-3].ident));
                   vlog_set_target((yyval.vlog), (yyvsp[-1].vlog));
                }
#line 3146 "../src/vlog/vlog-parse.c"
    break;

  case 155: /* pull_gate_instance: '(' lvalue ')'  */
#line 1103 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_GATE_INST);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-1].vlog));
                }
#line 3156 "../src/vlog/vlog-parse.c"
    break;

  case 156: /* pulldown_strength: '(' strength0 ',' strength1 ')'  */
#line 1112 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3166 "../src/vlog/vlog-parse.c"
    break;

  case 157: /* pulldown_strength: '(' strength1 ',' strength0 ')'  */
#line 1118 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3176 "../src/vlog/vlog-parse.c"
    break;

  case 158: /* pulldown_strength: '(' strength0 ')'  */
#line 1124 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3185 "../src/vlog/vlog-parse.c"
    break;

  case 159: /* pullup_strength: '(' strength0 ',' strength1 ')'  */
#line 1132 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3195 "../src/vlog/vlog-parse.c"
    break;

  case 160: /* pullup_strength: '(' strength1 ',' strength0 ')'  */
#line 1138 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3205 "../src/vlog/vlog-parse.c"
    break;

  case 161: /* pullup_strength: '(' strength1 ')'  */
#line 1144 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3214 "../src/vlog/vlog-parse.c"
    break;

  case 162: /* strength0: "supply0"  */
#line 1150 "../src/vlog/vlog-parse.y"
                         { (yyval.vlog) = make_strength(V_STRENGTH_SUPPLY0, &(yyloc)); }
#line 3220 "../src/vlog/vlog-parse.c"
    break;

  case 163: /* strength1: "supply1"  */
#line 1153 "../src/vlog/vlog-parse.y"
                         { (yyval.vlog) = make_strength(V_STRENGTH_SUPPLY1, &(yyloc)); }
#line 3226 "../src/vlog/vlog-parse.c"
    break;


#line 3230 "../src/vlog/vlog-parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= tEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == tEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 1156 "../src/vlog/vlog-parse.y"


static void yyerror(const char *s)
{
   error_at(&yylloc, "%s", s);
}

static void node_list_concat(node_list_t **a, node_list_t *b)
{
   if (*a == NULL)
      *a = b;
   else if (b != NULL) {
      assert((*a)->tail->next == NULL);
      (*a)->tail->next = b;
      (*a)->tail = b->tail;
   }
}

static void node_list_free(node_list_t *l)
{
   while (l != NULL) {
      node_list_t *next = l->next;
      free(l);
      l = next;
   }
}

static void node_list_append(node_list_t **l, vlog_node_t v)
{
   node_list_t *new = xmalloc(sizeof(node_list_t));
   new->next  = NULL;
   new->value = v;
   new->tail  = new;

   node_list_concat(l, new);
}

static node_list_t *node_list_single(vlog_node_t v)
{
   node_list_t *new = xmalloc(sizeof(node_list_t));
   new->next  = NULL;
   new->value = v;
   new->tail  = new;

   return new;
}

static void set_timescale(const char *unit_value, const char *unit_name,
                          const char *prec_value, const char *prec_name,
                          const loc_t *loc)
{
   // See IEEE 1800-2017 section 22.7 for rules

   struct {
      const char *value;
      const char *name;
      int64_t     parsed;
   } args[] = {
      { unit_value, unit_name },
      { prec_value, prec_name },
   };

   for (int i = 0; i < ARRAY_LEN(args); i++) {
      static const struct {
         const char *name;
         int64_t value;
      } valid_units[] = {
         { "s", INT64_C(60000000000000) },
         { "ms", 1000000000000 },
         { "us", 1000000000 },
         { "ns", 1000000 },
         { "ps", 1000 },
         { "fs", 1 },
      };

      bool name_valid = false;
      for (int j = 0; j < ARRAY_LEN(valid_units); j++) {
         if (strcmp(valid_units[j].name, args[i].name) == 0) {
            args[i].parsed = valid_units[j].value;
            name_valid = true;
            break;
         }
      }

      if (!name_valid)
         error_at(loc, "invalid time unit name '%s'", args[i].name);

      const int scale = atoi(args[i].value);
      if (scale != 1 && scale != 10 && scale != 100) {
         diag_t *d = diag_new(DIAG_ERROR, loc);
         diag_printf(d, "invalid order of magniture in `timescale directive");
         diag_hint(d, NULL, "the valid values are 1, 10, and 100");
         diag_emit(d);
      }

      args[i].parsed *= scale;
   }

   // TODO: do something with parsed scale/precision
}

static void clone_port(node_list_t **list, vlog_node_t p)
{
   node_list_t *last = NULL;
   for (node_list_t *it = *list; it != NULL; it = it->next) {
      if (vlog_kind(it->value) == V_PORT_DECL)
         last = it;
   }

   vlog_set_subkind(p, vlog_subkind(last->value));

   node_list_append(list, p);

   if (last->next && vlog_kind(last->next->value) == V_VAR_DECL) {
      vlog_node_t reg = vlog_new(V_VAR_DECL);
      vlog_set_loc(reg, vlog_loc(p));
      vlog_set_ident(reg, vlog_ident(p));

      node_list_append(list, reg);
   }
}

vlog_node_t vlog_parse(void)
{
   make_new_arena();
   root = NULL;

   scan_as_verilog();

   if (yyparse())
      return NULL;
   else
      return root;
}

void reset_verilog_parser(void)
{
}
